import urllib2
from xml.dom import minidom
import sys
import time
import socket

#feed-reader.py is meant as to be an RSS headline reader for the NerdKits LED array.
#To be used in conjuction with serial-comm.py
#suggested useage: % python feed-reader.py | python serial-comm.py

#set the feed_url variable for the feed you want ot read.
#feed_url = "http://sports.espn.go.com/espn/rss/mlb/news"
feed_url = "http://www.cnbc.com/id/19746125/device/rss/rss.xml"
#feed_url = "http://twitter.com/statuses/user_timeline/19753668.rss"
#feed_url = "http://search.twitter.com/search.rss?q=+nerdkit+OR+nerdkits"
#feed_url = "http://www.weather.gov/xml/current_obs/KSAN.rss"

sys.stdout.flush()
HOST = 'localhost'    # The remote host
PORT = 7777              # The same port as used by the server

while True:
  #use a socket to figure out ask serial-comm.py how many lines are currently in its buffer
  try:
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    s.connect((HOST, PORT))
    s.send('info')
    recieved_data = s.recv(1024)
    s.close() 
    print >> sys.stderr, "Reader: Info Resp " + str(recieved_data)
    data = int(recieved_data)

    if data < 2:
      #if less than 2 lines currenly in buffer, retrieve more headlines, and send them to the array.
      feed = minidom.parse(urllib2.urlopen(feed_url))
      for headline in feed.getElementsByTagName("item"):
        try:
          print headline.getElementsByTagName("title")[0].firstChild.wholeText.upper() + "       "
          sys.stdout.flush()
        except:
          print >> sys.stderr, "Unable to Send"

    time.sleep(5)
  except socket.error,msg:
    print >> sys.stderr, "Fail: " + str(msg)
    time.sleep(2)

